        struct
dBaseRange              ds 1                            ; 0 = random range for nBases
dBaseMin                ds 1                            ; 1 = min number of bases
dFuelRange              ds 1                            ; 2 = random range of fuel dumps
dSpaceRange             ds 1                            ; 3 = random range of spaceports
        send

; Build the universe

InitMapOfUniverse       LD HL,Map

IM_ClrLp                LD (HL),$00
                        INC H
                        LD (HL),$00
                        DEC H
                        INC L
                        JR NZ IM_ClrLp

                        LD IY,SectorCountPerSkillTab
                        LD A,(optSkillLevel)
                        LD E,A
                        LD D,0
                        ADD IY,DE

                        ; Put a random "tough" sector in to start with

                        CALL Rand
                        LD L,E
                        LD H,high Map

                        LD A,$FF
                        LD (WriteMap_LSB),A
                        LD A,$03
                        LD (WriteMap_MSB),A
                        CALL WriteToMap_HL

                        ; Now, add tough sectors to this one

                        LD B,(IY)

                        LD HL,$03FF
                        CALL AddSectorsToMap_HLB

                        ; Now, add next level

                        LD B,(IY)
                        LD HL,$02F8
                        CALL AddSectorsToMap_HLB

                        ; Now, add next level

                        LD B,(IY)
                        LD HL,$01E0
                        CALL AddSectorsToMap_HLB

                        ; Now, add lowest level

                        LD B,(IY)
                        LD HL,$00D0
                        CALL AddSectorsToMap_HLB

                        ; Remove the 'adjacent' link, or whatever the hell it was

                        LD HL,Map+$100
ClrAdjLp                LD A,(HL)
                        AND $03
                        LD (HL),A
                        INC L
                        JR NZ ClrAdjLp

                        ; Find a starting place in the map for us

FindRandomMapStart      CALL Rand

                        LD E,A
                        LD D,high Map

                        LD A,(DE)
                        BIT 7,A
                        JR Z FindRandomMapStart

                        INC D
                        LD A,(DE)
                        AND $03
                        JR NZ FindRandomMapStart

                        ; This isn't clear, start here

                        LD A,E
                        LD (CurrMapPosition),A
                        RET

; A table defining the size of the empire according to skill level

SectorCountPerSkillTab  db 5,10,20,30,41,50

; Add B sectors randomly of HL "type"

AddSectorsToMap_HLB     LD A,H
                        LD (WriteMap_MSB),A
                        LD A,L
                        LD (WriteMap_LSB),A

ASTM_Lp1                PUSH BC

ASTM_Lp2                CALL Rand
                        LD L,E
                        LD H,(high Map) +1
                        BIT 7,(HL)
                        JR Z ASTM_Lp2

                        DEC H
                        BIT 7,(HL)
                        JR NZ ASTM_Lp2

                        CALL WriteToMap_HL

                        POP BC
                        DJNZ ASTM_Lp1

                        RET

WriteToMap_HL           LD (HL),$00
WriteMap_LSB            EQU *-1
                        INC H
                        LD (HL),$00
WriteMap_MSB            EQU *-1
                        DEC H

                        ; Link U/D/L/R

                        CALL MoveMapPtr_HL_Left_IP
                        CALL SetLinkFlag
                        CALL MoveMapPtr_HL_Up_IP
                        CALL MoveMapPtr_HL_Right_IP
                        CALL SetLinkFlag
                        CALL MoveMapPtr_HL_Right_IP
                        CALL MoveMapPtr_HL_Down_IP
                        CALL SetLinkFlag
                        CALL MoveMapPtr_HL_Down_IP
                        CALL MoveMapPtr_HL_Left_IP

                        ; Fall into

SetLinkFlag             BIT 7,(HL)
                        RET NZ

                        INC H
                        SET 7,(HL)
                        DEC H
                        RET

MoveMapPtr_HL_Left_IP   LD A,L
                        AND $0F
                        RET Z

                        DEC L
                        RET

MoveMapPtr_HL_Right_IP  LD A,L
                        AND $0F
                        CP $0F
                        RET Z

                        INC L
                        RET

MoveMapPtr_HL_Up_IP     LD A,L
                        AND $F0
                        RET Z

                        LD A,L
                        SUB $10
                        LD L,A
                        RET

MoveMapPtr_HL_Down_IP   LD A,L
                        AND $F0
                        CP $F0
                        RET Z

                        LD A,L
                        ADD A,$10
                        LD L,A
                        RET

                        RET

; Setup a planet, A = Type

CreatePlanetMap         AND $03
                        LD L,A
                        LD H,0

                        ADD HL,HL
                        ADD HL,HL

                        LD DE,PlanetLevelDefTab
                        ADD HL,DE

                        PUSH HL
                        POP IX

                        ; Clear the planet

                        LD HL,MapOfPlanet
                        XOR A
ClrPlanetLp             LD (HL),A
                        INC L
                        JR NZ ClrPlanetLp

                        ; Setup the bases

                        LD A,(IX+dBaseRange)
                        CALL GetRandInRange8_B

                        LD A,(IX+dBaseMin)
                        ADD A,B
                        LD B,A
                        LD (nBasesOnPlanet),A

                        JR Z NoBasesOnPlanet

                        ; For each base, add it?

AddBaseLp               PUSH BC
                        CALL AddBaseToPlanet
                        POP BC
                        DJNZ AddBaseLp

                        ; Add fueldumps?

NoBasesOnPlanet         LD A,(IX+dFuelRange)
                        CALL GetRandInRange8_B

                        LD A,B
                        OR A
                        JR Z AddSpaceports

AddFuelDump_Lp          LD A,$18
                        CALL AddThingToPlanet_A
                        DJNZ AddFuelDump_Lp

                        ; Add spaceports

AddSpaceports           LD A,(IX+dSpaceRange)
                        CALL GetRandInRange8_B

                        LD A,B
                        OR A
                        JR Z CreatePlanet_X

AddSpaceport_Lp         LD A,$28
                        CALL AddThingToPlanet_A
                        DJNZ AddSpaceport_Lp

CreatePlanet_X          RET

PlanetLevelDefTab       DEFB $00,$01,$01,$01
                        DEFB $01,$01,$03,$02
                        DEFB $02,$02,$06,$03
                        DEFB $03,$02,$09,$05

; Add something to the planet map

AddThingToPlanet_A      PUSH BC

                        PUSH AF

ATTP_NotEmptyLp         CALL Rand

                        LD D,high MapOfPlanet
                        LD A,(DE)
                        OR A
                        JR NZ ATTP_NotEmptyLp

                        POP AF

                        LD (DE),A

                        POP BC
                        RET

; Put the base on the map

AddBaseToPlanet         CALL Rand

                        LD D,high MapOfPlanet
                        LD A,(DE)
                        CP $10
                        JR NC AddBaseToPlanet

                        LD A,$30
                        LD (DE),A

                        CALL MoveMapPtr_DE_Up
                        CALL MoveMapPtr_DE_Left

                        LD B,2
ABTP_Lp1                CALL IncMapSquareLevelTwice
                        CALL MoveMapPtr_DE_Right
                        DJNZ ABTP_Lp1

                        CALL IncMapSquareLevelTwice

                        LD B,2
ABTP_Lp2                CALL MoveMapPtr_DE_Down
                        CALL IncMapSquareLevelTwice
                        DJNZ ABTP_Lp2

                        LD B,2
ABTP_Lp3                CALL MoveMapPtr_DE_Left
                        CALL IncMapSquareLevelTwice
                        DJNZ ABTP_Lp3

                        CALL MoveMapPtr_DE_Up
                        CALL IncMapSquareLevelTwice
                        CALL MoveMapPtr_DE_Up
                        CALL MoveMapPtr_DE_Up
                        CALL MoveMapPtr_DE_Left

                        LD B,4
ABTP_Lp4                CALL IncMapSquareLevel
                        CALL MoveMapPtr_DE_Right
                        DJNZ ABTP_Lp4

                        CALL IncMapSquareLevel

                        LD B,4
ABTP_Lp5                CALL MoveMapPtr_DE_Down
                        CALL IncMapSquareLevel
                        DJNZ ABTP_Lp5

                        LD B,4

ABTP_Lp6                CALL MoveMapPtr_DE_Left
                        CALL IncMapSquareLevel
                        DJNZ ABTP_Lp6

                        LD B,3
ABTP_Lp7                CALL MoveMapPtr_DE_Up
                        CALL IncMapSquareLevel
                        DJNZ ABTP_Lp7

                        RET

IncMapSquareLevelTwice  CALL IncMapSquareLevel

IncMapSquareLevel       LD A,(DE)
                        CP $0F
                        RET NC

                        INC A
                        LD (DE),A
                        RET

MoveMapPtr_DE_Left      DEC E
                        LD A,E
                        OR $F0
                        INC A
                        RET NZ

                        LD A,E
                        ADD A,$10
                        LD E,A
                        RET

MoveMapPtr_DE_Right     INC E
                        LD A,E
                        AND $0F
                        RET NZ

                        LD A,E
                        SUB $10
                        LD E,A
                        RET

MoveMapPtr_DE_Up        LD A,E
                        SUB $10
                        LD E,A
                        RET

MoveMapPtr_DE_Down      LD A,E
                        ADD A,$10
                        LD E,A
                        RET

;

SetupDisplayEtc         LD A,(optVarDisplayMode)        ;
                        OR A                            ;
                        JR Z LB015                      ;

                        DEC A                           ;
                        JR Z LB024                      ;

                        DEC A                           ;
                        JR Z LB034                      ;

                        XOR A                           ;
                        LD (LC35D),A                    ;
                        LD (LC361),A                    ;
                        JR LB042                        ;

LB015                   LD A,$D8                        ;
                        LD (LC35D),A                    ;
                        LD (LC361),A                    ;

                        LD A,$AD                        ;
                        LD (LC35F),A                    ;

                        JR LB042                        ;

LB024                   LD A,$D8                        ;
                        LD (LC361),A                    ;

                        XOR A                           ;
                        LD (LC35D),A                    ;

                        LD A,$9E                        ;
                        LD (LC35F),A                    ;

                        JR LB042                        ;

LB034                   LD A,$D8                        ;
                        LD (LC361),A                    ;

                        XOR A                           ;
                        LD (LC35D),A                    ;

                        LD A,$A7                        ;
                        LD (LC35F),A                    ;

LB042                   LD A,(optNoises)                ;
                        RRCA                            ;
                        CCF                             ;
                        LD A,$FE                        ;
                        ADC A,$00                       ;
                        LD (smcNoise6),A                ;
                        LD (smcNoise7),A                ;
                        RET                             ;

;

DrawMapOutline          LD HL,$424F                     ;
                        LD DE,$584F                     ;
                        CALL DrawHorizOutline           ;

                        LD HL,$526F                     ;
                        LD DE,$5A6F                     ;
                        CALL DrawHorizOutline           ;

                        LD HL,$406E                     ;
                        LD DE,$586E                     ;
                        CALL DrawVertOutline            ;

                        LD HL,$407F                     ;
                        LD DE,$587F                     ;
                        CALL DrawVertOutline            ;

                        LD A,$88                        ;
                        LD HL,$404E                     ;
                        CALL LCFB3                      ;

                        LD A,$90                        ;
                        LD HL,$405F                     ;
                        CALL LCFB3                      ;

                        LD A,$A0                        ;
                        LD HL,$506E                     ;
                        CALL LCFB3                      ;

                        LD A,$98                        ;
                        LD HL,$507F                     ;
                        CALL LCFB3                      ;
                        RET                             ;

DrawHorizOutline        LD B,16                         ;
LCA8D                   LD (HL),$FF                     ;
                        INC H                           ;
                        INC H                           ;
                        INC H                           ;
                        LD (HL),$FF                     ;
                        DEC H                           ;
                        DEC H                           ;
                        DEC H                           ;
                        INC L                           ;
                        LD A,$06                        ;
                        LD (DE),A                       ;
                        INC E                           ;
                        DJNZ LCA8D                      ;

                        RET                             ;

DrawVertOutline         LD B,16                         ;
LCAA1                   LD A,$01                        ;
LCAA3                   LD (HL),$24                     ;
                        INC H                           ;
                        RLCA                            ;
                        JR NC LCAA3                     ;

                        LD A,L                          ;
                        ADD A,$20                       ;
                        LD L,A                          ;
                        JR C LCAB3                      ;

                        LD A,H                          ;
                        SUB $08                         ;
                        LD H,A                          ;
LCAB3                   DJNZ LCAA1                      ;

                        EX DE,HL                        ;
                        LD DE,32                        ;
                        LD B,16                         ;
LCABB                   LD (HL),$46                     ;
                        ADD HL,DE                       ;
                        DJNZ LCABB                      ;

                        RET                             ;

ShowSpaceInfo           LD DE,AttrList_Info2            ;
                        LD HL,$5840                     ;
                        CALL WriteAttrFromList_DE       ;

                        CALL DrawMapOutline             ;

                        LD A,$77                        ;
                        LD B,A                          ;
                        LD A,$07                        ;
LCAD2                   CALL LDA99                      ;
                        CALL LDAA8                      ;
                        DEC A                           ;
                        JR NZ LCAD2                     ;

                        LD IX,YTable+24                 ;
                        LD C,$10                        ;
LCAE1                   PUSH BC                         ;
                        LD DE,$000F                     ;
                        CALL LCBE6                      ;
                        POP BC                          ;
                        CALL LDAAF                      ;
                        LD DE,$0008                     ;
                        ADD IX,DE                       ;
                        DEC C                           ;
                        JR NZ LCAE1                     ;

                        XOR A                           ;
                        LD (CurX),A                     ;
                        LD A,$03                        ;
                        LD (CurpY),A                    ;
                        LD HL,$4040                     ;
                        LD (CurY),HL                    ;
                        CALL ShowStrFollow              ;
                        DEFB "Tactical Galactic",$0D
                        DEFB "Sector Scan",$0D,$0D,$0D,$0D
                        DEFB "   Lightly Defended",$0D,$0D
                        DEFB "   Well Defended",$0D,$0D ;
                        DEFB "   Heavily Defended",$0D,$0D
                        DEFB "   Military Center",$00   ;

                        LD HL,$4800                     ;
                        LD E,$A8                        ;
                        CALL LCFB4                      ;
                        LD HL,$4840                     ;
                        LD E,$B0                        ;
                        CALL LCFB4                      ;
                        LD HL,$4880                     ;
                        LD E,$B8                        ;
                        CALL LCFB4                      ;
                        LD HL,$48C0                     ;
                        LD E,$C0                        ;
                        CALL LCFB4                      ;
                        LD HL,$0001                     ;
                        LD (LCBB8),HL                   ;
                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        AND $01                         ;
                        LD (LCBAC),A                    ;
LCBA5                   LD A,$F7                        ;
                        IN A,($FE)                      ;
                        AND $01                         ;
                        LD B,0                          ;
LCBAC                   EQU *-1                         ;
                        CP B                            ;
                        LD (LCBAC),A                    ;
                        JR Z LCBB7                      ;

                        BIT 0,A                         ;
                        JR Z LCBE5                      ;

LCBB7                   LD HL,$0000                     ;
LCBB8                   EQU *-2                         ;
                        DEC HL                          ;
                        LD (LCBB8),HL                   ;
                        LD A,L                          ;
                        OR H                            ;
                        JR NZ LCBA5                     ;

                        LD HL,$1F40                     ;
                        LD (LCBB8),HL                   ;
                        LD HL,$0000                     ;
LCBC9                   EQU *-2                         ;
                        LD A,(HL)                       ;
                        CPL                             ;
                        LD (HL),A                       ;
                        INC H                           ;
                        LD A,(HL)                       ;
                        CPL                             ;
                        LD (HL),A                       ;
                        LD B,4                          ;
LCBD4                   INC H                           ;
                        LD A,(HL)                       ;
                        XOR $C3                         ;
                        LD (HL),A                       ;
                        DJNZ LCBD4                      ;

                        INC H                           ;
                        LD A,(HL)                       ;
                        CPL                             ;
                        LD (HL),A                       ;
                        INC H                           ;
                        LD A,(HL)                       ;
                        CPL                             ;
                        LD (HL),A                       ;
                        JR LCBA5                        ;

LCBE5                   RET                             ;

LCBE6                   LD C,$10                        ;
LCBE8                   LD L,B                          ;
                        LD H,high Map                   ;
                        LD A,L                          ;
                        LD L,(IX)                       ;
                        INC IXH                         ;
                        LD H,(IX)                       ;
                        DEC IXH                         ;
                        ADD HL,DE                       ;
                        CALL LCC02                      ;
                        INC DE                          ;
                        CALL LDA8B                      ;
                        DEC C                           ;
                        JR NZ LCBE8                     ;

                        RET                             ;

LCC02                   PUSH DE                         ;
                        PUSH BC                         ;
                        LD E,A                          ;
                        LD D,high Map                   ;
                        LD A,(CurrMapPosition)          ;
                        CP E                            ;
                        JR Z LCC22                      ;

                        LD A,(DE)                       ;
                        BIT 7,A                         ;
                        JR Z LCC1F                      ;

LCC12                   INC D                           ;
                        LD A,(DE)                       ;
                        AND $03                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,$A8                       ;
LCC1B                   LD E,A                          ;
                        CALL LCFB4                      ;
LCC1F                   POP BC                          ;
                        POP DE                          ;
                        RET                             ;

LCC22                   LD (LCBC9),HL                   ;
                        LD A,(DE)                       ;
                        BIT 7,A                         ;
                        LD A,$E8                        ;
                        JR Z LCC1B                      ;

                        JR LCC12                        ;

;

ShowPlanetData          LD DE,AttrList_PlanetData       ;
                        LD HL,$5840                     ;
                        CALL WriteAttrFromList_DE       ;

                        LD HL,LCCDC                     ;
                        LD DE,$4784                     ;
                        LD BC,$0008                     ;
                        LDIR                            ;

                        LD HL,LCCE4                     ;
                        LD DE,$47A4                     ;
                        LD BC,$0008                     ;
                        LDIR                            ;

                        CALL DrawMapOutline             ;

                        LD A,(LDA61)                    ;
                        LD B,A                          ;
                        LD A,$07                        ;

LCC56                   CALL LDA99                      ;
                        CALL LDAA8                      ;
                        DEC A                           ;
                        JR NZ LCC56                     ;

                        LD IX,YTable+24                 ;
                        LD C,$10                        ;

LCC65                   PUSH BC                         ;
                        LD DE,$000F                     ;
                        CALL LCF5D                      ;
                        POP BC                          ;

                        CALL LDAAF                      ;

                        LD DE,$0008                     ;
                        ADD IX,DE                       ;

                        DEC C                           ;
                        JR NZ LCC65                     ;

                        LD A,(ArrowDirn)                ;
                        LD HL,$4856                     ;
                        CALL ShowArrow                  ;

                        XOR A                           ;
                        LD (CurX),A                     ;

                        LD A,$03                        ;
                        LD (CurpY),A                    ;

                        LD HL,$4040                     ;
                        LD (CurY),HL                    ;

                        CALL ShowStrFollow              ;

                        DEFB "Planetary Data",$0D,$0D   ;
                        DEFB "Name  ",$91,$F0,$0D,$0D
                        DEFB "Type  ",$90,$F1,$0D,$0D
                        DEFB "Size  ",$93,$F2,$0D,$0D
                        DEFB "Mass  ",$F3,$0D,$0D
LCCCA                   DEFB $F4,$0D,$F6,$0D,$0D
                        DEFB "Comments",$0D,$F7,$0D
                        DEFB 0

                        RET                             ;

LCCDC                   DEFB $7F,$FF,$FF,$FF,$FF,$FF,$FF,$FE;
LCCE4                   DEFB $80,$00,$00,$00,$00,$00,$00,$01;

WriteAttrFromList_DE    LD A,(DE)                       ;
                        OR A                            ;
                        RET Z                           ;

                        INC DE                          ;
                        LD C,A                          ;
                        LD A,(DE)                       ;
                        INC DE                          ;
                        LD B,A                          ;
LCCF4                   LD (HL),C                       ;
                        INC HL                          ;
                        DJNZ LCCF4                      ;

                        JR WriteAttrFromList_DE         ;

AttrList_PlanetData     DEFB $45,$0A
                        DEFB $47,$36
                        DEFB $47,$04
                        DEFB $06,$09
                        DEFB $07,$13
                        DEFB $46,$04
                        DEFB $30,$08
                        DEFB $07,$34
                        DEFB $46,$04
                        DEFB $47,$3C
                        DEFB $46,$04
                        DEFB $47,$3C
                        DEFB $46,$04
                        DEFB $47,$3C
                        DEFB $43,$09
                        DEFB $47,$77
                        DEFB $44,$09
                        DEFB $00

AttrList_Info2          DEFB $45,$0E
                        DEFB $40,$32
                        DEFB $45,$0E
                        DEFB $40,$32
                        DEFB $40,$40
                        DEFB $46,$0E
                        DEFB $40,$32
                        DEFB $46,$0E
                        DEFB $40,$32
                        DEFB $46,$0E
                        DEFB $40,$32
                        DEFB $46,$0E
                        DEFB $40,$32
                        DEFB $00,$00

LCD39                   DEFB "None",$0D,$00             ;
LCD3F                   DEFB "Poisonous",$0D,$00        ;
LCD4A                   DEFB "Primordial",$0D,$00       ;
LCD56                   DEFB "Nitrous Oxide",$0D,$00    ;
LCD65                   DEFB "Not for programmers",$0D,$00;
LCD7A                   DEFB "Bit nasty",$0D,$00        ;
LCD85                   DEFB "Rain Expected",$0D,$00    ;
LCD94                   DEFB "Cold, wet and awful",$0D,"Just like Manchester",$00;

LCDBE                   DEFB "Harmless",$00             ;
LCDC7                   DEFB "Mostly Harmless",$00      ;
LCDD7                   DEFB "Hate It !",$00            ;
LCDE1                   DEFB "Mott ! Mott !",$00        ;
LCDEF                   DEFB "How many months ?",$00    ;
LCE01                   DEFB "Ugh !",$00                ;
LCE07                   DEFB "Call this a planet ?",$00 ;
LCE1C                   DEFB "I'm sure I've seen",$0D,"this somewhere ?",$00;

LCE40                   DEFB "Outpost",$00              ;
LCE48                   DEFB "Desolate",$00             ;
LCE51                   DEFB "Inhabited",$00            ;
LCE5B                   DEFB "Habitable",$00            ;
LCE65                   DEFB "Military",$00             ;
LCE6E                   DEFB "Occupied",$00             ;
LCE77                   DEFB "Military Base",$00        ;
LCE85                   DEFB "Military HQ",$00          ;

AtmosphereStr_Tab       DEFW LCD39,LCD3F,LCD4A,LCD56,LCD65,LCD7A,LCD85,LCD94;
CommentStr_Tab          DEFW LCDBE,LCDC7,LCDD7,LCDE1,LCDEF,LCE01,LCE07,LCE1C;
PlanetTypeStr_Tab       DEFW LCE40,LCE48,LCE51,LCE5B,LCE65,LCE6E,LCE77,LCE85;

ShowStrFollow           EX (SP),HL                      ;
                        PUSH AF                         ;
LCEC3                   LD A,(HL)                       ;
                        INC HL                          ;
                        OR A                            ;
                        JR Z LCED1                      ;

                        CP $F0                          ;
                        JR NC LCED4                     ;

                        CALL $6A83                      ;
                        JR LCEC3                        ;

LCED1                   POP AF                          ;
                        EX (SP),HL                      ;
                        RET                             ;

LCED4                   SUB $F0                         ;
                        JR Z ShowNumberPlate            ;

                        DEC A                           ;
                        JR Z LCF49                      ;

                        DEC A                           ;
                        JR Z ShowSize                   ;

                        DEC A                           ;
                        JR Z ShowMass                   ;

                        DEC A                           ;
                        JR Z ShowAtmosphere             ;

                        DEC A                           ;
                        JR Z ShowNightLife              ;

                        DEC A                           ;
                        JR Z LCF33                      ;

                        DEC A                           ;
                        JR Z LCF3E                      ;

                        JR LCEC3                        ;

ShowNumberPlate         CALL ShowStrFollow              ;
sNumberPlateBuff        DEFB "KMN 555 F",$00            ;
                        JR LCEC3                        ;

ShowSize                CALL ShowStrFollow              ;
                        DEFB "1."                       ;
sSizeDigit1             DEFB "3"                        ;
sSizeDigit2             DEFB "5"                        ;
                        NOP                             ;
                        JR LCEC3                        ;

ShowMass                CALL ShowStrFollow              ;
                        DEFB "1."                       ;
sMassDigit1             DEFB "1"                        ;
sMassDigit2             DEFB "7",$00                    ;
                        JR LCEC3                        ;

ShowAtmosphere          CALL ShowStrFollow              ;
                        DEFB "Atmosphere",$00           ;
                        JR LCEC3                        ;

ShowNightLife           CALL ShowStrFollow              ;
                        DEFB "Night-Life",$00           ;
                        JP LCEC3                        ;

LCF33                   PUSH HL                         ;
                        LD HL,LCD94                     ;
AtmosphereStrAddr       EQU *-2                         ;
                        CALL LCF54                      ;
                        POP HL                          ;
                        JP LCEC3                        ;

LCF3E                   PUSH HL                         ;
                        LD HL,LCD94                     ;
CommentStrAddr          EQU *-2                         ;
                        CALL LCF54                      ;
                        POP HL                          ;
                        JP LCEC3                        ;

LCF49                   PUSH HL                         ;
                        LD HL,LCE40                     ;
PlanetTypeStrAddr       EQU *-2                         ;
                        CALL LCF54                      ;
                        POP HL                          ;
                        JP LCEC3                        ;

LCF54                   LD A,(HL)                       ;
                        OR A                            ;
                        RET Z                           ;

                        INC HL                          ;
                        CALL $6A83                      ;
                        JR LCF54                        ;

LCF5D                   LD C,$10                        ;
LCF5F                   LD L,B                          ;
                        LD H,high MapOfPlanet           ;
                        LD A,(HL)                       ;
                        LD L,(IX)                       ;
                        INC IXH                         ;
                        LD H,(IX)                       ;
                        DEC IXH                         ;
                        ADD HL,DE                       ;
                        CALL LCF79                      ;
                        INC DE                          ;
                        CALL LDA8B                      ;
                        DEC C                           ;
                        JR NZ LCF5F                     ;

                        RET                             ;

LCF79                   OR A                            ;
                        RET Z                           ;

                        PUSH DE                         ;
                        PUSH BC                         ;
                        CP $10                          ;
                        JR NC LCF8E                     ;

                        CP $07                          ;
                        JR C LCF87                      ;

                        LD A,$06                        ;
LCF87                   DEC A                           ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        LD E,A                          ;
                        JR LCFA5                        ;

LCF8E                   AND $F0                         ;
                        CP $10                          ;
                        LD E,$40                        ;
                        JR Z LCFA5                      ;

                        CP $20                          ;
                        LD E,$38                        ;
                        JR Z LCFA5                      ;

                        CP $30                          ;
                        LD E,$30                        ;
                        JR Z LCFA5                      ;

                        POP BC                          ;
                        POP DE                          ;
                        RET                             ;

LCFA5                   CALL LCFB4                      ;
                        POP BC                          ;
                        POP DE                          ;
                        RET                             ;

ShowArrow               INC A                           ;
                        AND $07                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,low GameArrows            ;
LCFB3                   LD E,A                          ;
LCFB4                   LD D,high GameArrows            ;
                        LD B,8                          ;
LCFB8                   LD A,(DE)                       ;
                        LD (HL),A                       ;
                        INC E                           ;
                        INC H                           ;
                        DJNZ LCFB8                      ;

                        LD A,H                          ;
                        SUB $08                         ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $03                         ;
                        OR $58                          ;
                        LD H,A                          ;
                        LD A,E                          ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        DEC A                           ;
                        AND $1F                         ;
                        ADD A,low CharAttrs             ;
                        LD E,A                          ;
                        LD A,high CharAttrs             ;
                        ADC A,$00                       ;
                        LD D,A                          ;
                        LD A,(DE)                       ;
                        LD (HL),A                       ;
                        RET                             ;

CharAttrs               DEFB $05,$45,$06,$46,$07,$47,$47,$43;
                        DEFB $45,$47,$47,$47,$47,$47,$47,$47;
                        DEFB $47,$06,$06,$06,$06,$41,$02,$03;
                        DEFB $04,$41,$42,$43,$44,$05    ;

SetupPlanetMode         LD HL,LC593
                        LD (LDBE4),HL                   ;

                        LD HL,LC5C5
                        LD (LDBFA),HL                   ;

                        LD HL,LC61E                     ;
                        LD (LDC10),HL                   ;

                        ; Select a random type of spaceship for this planet

                        LD HL,Table_8x_ShipMoves        ;
                        CALL GetRandomFromTab8w         ;
                        LD (PlanetsShipMoveRoutine+1),HL;

                        LD A,R                          ;
                        AND $1F                         ;
                        LD A,$F4                        ;
                        JR NZ LD01E                     ;

                        LD A,$F5                        ;
LD01E                   LD (LCCCA),A                    ;

                        LD HL,sNumberPlateBuff          ;
                        LD B,3                          ;
LD026                   CALL GetNumerPlateChar          ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        DJNZ LD026                      ;

                        LD (HL),$20                     ;
                        INC HL                          ;

                        ; Add a non-zero first digit

LD030                   CALL GetRandomDigit             ;
                        CP $30                          ;
                        JR Z LD030                      ;

                        LD (HL),A                       ;
                        INC HL                          ;

                        ; Then 2 more random ones

                        LD B,2                          ;
LD03B                   CALL GetRandomDigit             ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        DJNZ LD03B                      ;

                        LD (HL),$20                     ;
                        INC HL                          ;

                        ; And a letter

                        CALL GetNumerPlateChar          ;
                        LD (HL),A                       ;

                        ; + size/mass digits

                        CALL GetRandomDigit             ;
                        LD (sSizeDigit1),A              ;
                        CALL GetRandomDigit             ;
                        LD (sSizeDigit2),A              ;
                        CALL GetRandomDigit             ;
                        LD (sMassDigit1),A              ;
                        CALL GetRandomDigit             ;
                        LD (sMassDigit2),A              ;

                        ; Atmosphere string

                        CALL Rand                       ;
                        LD A,E                          ;
                        AND $07                         ;
                        ADD A,A                         ;
                        ADD A,low AtmosphereStr_Tab     ;
                        LD L,A                          ;
                        LD A,$00                        ;
                        ADC A,high AtmosphereStr_Tab    ;
                        LD H,A                          ;
                        LD A,(HL)                       ;
                        INC HL                          ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        LD (AtmosphereStrAddr),HL       ;

                        ; Comment string

                        CALL Rand                       ;
                        LD A,D                          ;
                        AND $07                         ;
                        ADD A,A                         ;
                        ADD A,low CommentStr_Tab        ;
                        LD L,A                          ;
                        LD A,$00                        ;
                        ADC A,high CommentStr_Tab       ;
                        LD H,A                          ;
                        LD A,(HL)                       ;
                        INC HL                          ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        LD (CommentStrAddr),HL          ;

                        ; Type description

                        LD A,R                          ;
                        LD B,A                          ;
                        LD A,(CurrPlanetType)           ;
                        AND $03                         ;
                        RR B                            ;
                        ADC A,A                         ;
                        ADD A,A                         ;
                        ADD A,low PlanetTypeStr_Tab     ;
                        LD L,A                          ;
                        LD A,$00                        ;
                        ADC A,high PlanetTypeStr_Tab    ;
                        LD H,A                          ;
                        LD A,(HL)                       ;
                        INC HL                          ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        LD (PlanetTypeStrAddr),HL       ;

                        ;

                        LD A,24                         ;
                        CALL InitStars                  ;

LD0AD                   LD HL,$4004                     ;
                        LD A,(optVarDisplayMode)        ;
                        OR A                            ;
                        JR Z LD0BC                      ;

                        LD HL,$50DF                     ;
                        CP $03                          ;
                        RET Z                           ;

LD0BC                   LD A,(ArrowDirn)                ;
                        JP ShowArrow                    ;

GetNumerPlateChar       PUSH HL                         ;
                        PUSH BC                         ;
LD0C4                   CALL Rand                       ;
                        LD A,E                          ;
                        AND $1F                         ;
                        CP $1A                          ;
                        JR NC LD0C4                     ;

                        ADD A,$41                       ;
                        POP BC                          ;
                        POP HL                          ;
                        CP $49                          ;
                        JR Z GetNumerPlateChar          ;

                        CP $4F                          ;
                        JR Z GetNumerPlateChar          ;

                        CP $55                          ;
                        JR Z GetNumerPlateChar          ;

                        CP $51                          ;
                        JR Z GetNumerPlateChar          ;

                        CP $5A                          ;
                        JR Z GetNumerPlateChar          ;

                        RET                             ;

;

GetRandomDigit          PUSH HL                         ;
                        PUSH BC                         ;

LD0E9                   CALL Rand                       ;

                        LD A,E                          ;
                        AND $0F                         ;
                        CP $09                          ;
                        JR NC LD0E9                     ;

                        ADD A,$30                       ;

                        POP BC                          ;
                        POP HL                          ;
                        RET                             ;


