; Stuff related to ships and missiles?

RecalcShipMoveIfTime    DEC (IX+dObjeTimeToNextRecalc)  ;
                        RET NZ                          ;

                        ; Fall into

RecalcShipMove          LD A,$10                        ;
                        LD (IX+dObjeTimeToNextRecalc),A ;

                        LD A,$28                        ;
                        EX AF,AF'                       ;
                        LD HL,(DeltaX)                  ;
                        mNegHL()                        ;
                        CALL Mult_AltA                  ;

                        LD DE,(IX+dObjeX)               ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD E,(IX+29)                    ;
                        LD D,(IX+30)                    ;

                        LD A,R                          ;
                        AND $78                         ;
                        JR NZ LB506                     ;

                        CALL GetRandDE_InRange          ;
                        LD (IX+dW_Unk1),DE              ;

LB506                   ADD HL,DE                       ;
                        CALL Div_Alt_A                  ;
                        LD DE,(IX+dObjedX)              ;
                        ADD HL,DE                       ;
                        SRA H                           ;
                        RR L                            ;
                        LD (IX+dObjedX),HL              ;

                        LD HL,(DeltaY)                  ;
                        mNegHL()                        ;
                        CALL Mult_AltA                  ;
                        LD DE,(IX+dObjeY)               ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD DE,(IX+dW_Unk2)              ;

                        LD A,R                          ;
                        AND $78                         ;
                        JR NZ LB542                     ;

                        CALL GetRandDE_InRange          ;
                        LD (IX+dW_Unk2),DE              ;

LB542                   CALL GetRandDE_InRange          ;
                        ADD HL,DE                       ;
                        CALL Div_Alt_A                  ;

                        LD DE,(IX+dObjedY)              ;
                        ADD HL,DE                       ;
                        SRA H                           ;
                        RR L                            ;
                        LD (IX+dObjedY),HL              ;

                        LD HL,(DeltaZ)                  ;
                        mNegHL()                        ;
                        CALL Mult_AltA                  ;

                        LD DE,(IX+dObjeZ)               ;
                        OR A                            ;
                        SBC HL,DE                       ;

                        LD DE,$1388                     ;
                        ADD HL,DE                       ;

                        CALL Div_Alt_A                  ;

                        LD DE,(IX+dObjedZ)              ;
                        ADD HL,DE                       ;
                        SRA H                           ;
                        RR L                            ;
                        LD (IX+dObjedZ),HL              ;

                        RET                             ;

Mult_AltA               LD E,$00                        ;
                        EX AF,AF'                       ;
                        LD D,A                          ;
                        EX AF,AF'                       ;
                        JP SignMult                     ;

Div_Alt_A               LD E,$00                        ;
                        EX AF,AF'                       ;
                        LD D,A                          ;
                        EX AF,AF'                       ;
                        JP SignDiv                      ;

GetRandDE_InRange       LD A,R                          ;
                        LD E,A                          ;
                        LD A,R                          ;
                        AND $3F                         ;
                        LD D,A                          ;
                        LD A,R                          ;
                        AND $08                         ;
                        RET Z                           ;

                        mNegDE()                        ;
                        RET                             ;

; Draw a missile

DrawMissile             LD A,(IX+dObjeCol)              ; Cycle the colour
                        INC A                           ;
                        AND $07                         ;
                        JR NZ DM_NotBlack               ;

                        LD A,$04                        ;
DM_NotBlack             OR $40                          ;
                        LD (IX+dObjeCol),A              ;

                        ; If we're on the planet we can't go underground

                        LD A,(GameMode_SPT)             ;
                        OR A                            ;
                        JR NZ DM_NotPlanet              ;

                        LD HL,(TempY)                   ;
                        LD DE,(GroundY)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        ; Not underground

DM_NotPlanet            LD HL,(TempX)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB8AB),HL                   ;

                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        LD A,H                          ;
                        OR A                            ;
                        RET NZ                          ;

                        LD HL,(TempY)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB667),HL                   ;

                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        LD A,H                          ;
                        OR A                            ;
                        RET NZ                          ;

                        LD HL,(TempZ)                   ;

                        SRA H                           ; Scale Z so they remain visible
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;

                        LD (TempZ),HL                   ;

                        INC (IX+dObjeMissAngle)         ;

                        LD A,(IX+dObjeMissAngle)        ;
                        AND $03                         ;
                        JP Z DM_Angle0                  ;

                        DEC A                           ;
                        JP Z DM_Angle1                  ;

                        DEC A                           ;
                        JP Z DM_Angle2                  ;

                        LD HL,$0000                     ;
                        EXX                             ;
                        LD HL,$0028                     ;
                        JP DM_GotAngle                  ;

DM_Angle2               LD HL,$0010                     ;
                        EXX                             ;
                        LD HL,$0024                     ;
                        JP DM_GotAngle                  ;

DM_Angle1               LD HL,$0020                     ;
                        EXX                             ;
                        LD HL,$0020                     ;
                        JP DM_GotAngle                  ;

DM_Angle0               LD HL,$0024                     ;
                        EXX                             ;
                        LD HL,$0010                     ;

DM_GotAngle             LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;

                        EX DE,HL                        ;
                        EXX                             ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        EX DE,HL                        ;

                        LD HL,(LB8AB)                   ;
                        ADD HL,DE                       ;

                        LD (LB6AB),HL                   ;
                        OR A                            ;
                        SBC HL,DE                       ;

                        OR A                            ;
                        SBC HL,DE                       ;

                        LD (LB6AE),HL                   ;

                        LD HL,$0000                     ;
LB667                   EQU *-2                         ;
LB668                   EQU *-1                         ;
                        ADD HL,DE                       ;
                        LD (LB6B7),HL                   ;

                        OR A                            ;
                        SBC HL,DE                       ;

                        OR A                            ;
                        SBC HL,DE                       ;

                        LD (LB6B4),HL                   ;
                        EXX                             ;
                        LD HL,(LB8AB)                   ;
                        ADD HL,DE                       ;
                        LD (LB6BE),HL                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB6BB),HL                   ;
                        LD HL,(LB667)                   ;
                        ADD HL,DE                       ;
                        LD (LB6A7),HL                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB6A4),HL                   ;

                        ; Undraw it

                        PUSH IX                         ;
                        POP IY                          ;

                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;

                        CALL RemoveLines                ;

                        LD HL,$0000                     ;
LB6A4                   EQU *-2                         ;
                        LD DE,$0000                     ;
LB6A7                   EQU *-2                         ;
                        EXX                             ;
                        LD HL,$0000                     ;
LB6AB                   EQU *-2                         ;
                        LD DE,$0000                     ;
LB6AE                   EQU *-2                         ;
                        CALL AnyLine                    ;

                        LD HL,$0000                     ;
LB6B4                   EQU *-2                         ;
                        LD DE,$0000                     ;
LB6B7                   EQU *-2                         ;
                        EXX                             ;
                        LD HL,$0000                     ;
LB6BB                   EQU *-2                         ;
                        LD DE,$0000                     ;
LB6BE                   EQU *-2                         ;
                        JP AnyLine                      ;

;

DrawExplosion           LD HL,(TempX)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB8AB),HL                   ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        LD A,H                          ;
                        OR A                            ;
                        RET NZ                          ;

                        LD HL,(TempY)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB667),HL                   ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        LD A,H                          ;
                        OR A                            ;
                        RET NZ                          ;

                        LD HL,(IX+dW_Unk2)              ;
                        PUSH HL                         ;
                        POP IY                          ;
                        LD HL,(TempZ)                   ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        LD (TempZ),HL                   ;

                        LD L,(IY)                       ;
                        LD A,L                          ;
                        OR A                            ;
                        RET Z                           ;

                        LD H,0                          ;
                        INC IY                          ;

                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        EX DE,HL                        ;
                        LD HL,(LB8AB)                   ;
                        LD B,H                          ;
                        LD C,L                          ;
                        ADD HL,DE                       ;
                        LD (LB79D),HL                   ;
                        LD H,B                          ;
                        LD L,C                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB7AD),HL                   ;
                        SRA D                           ;
                        RR E                            ;
                        LD H,B                          ;
                        LD L,C                          ;
                        ADD HL,DE                       ;
                        LD (LB7A0),HL                   ;
                        LD H,B                          ;
                        LD L,C                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB7AA),HL                   ;
                        LD L,(IY)                       ;
                        LD H,0                          ;
                        INC IY                          ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        EX DE,HL                        ;
                        LD HL,(LB667)                   ;
                        LD B,H                          ;
                        LD C,L                          ;
                        ADD HL,DE                       ;
                        LD (LB7D7),HL                   ;
                        LD H,B                          ;
                        LD L,C                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB7CA),HL                   ;
                        SRA D                           ;
                        RR E                            ;
                        LD H,B                          ;
                        LD L,C                          ;
                        ADD HL,DE                       ;
                        LD (LB7BD),HL                   ;
                        LD H,B                          ;
                        LD L,C                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB7B0),HL                   ;
                        LD A,(IY)                       ;
                        LD (Colour),A                   ;
                        INC IY                          ;
                        PUSH IY                         ;
                        POP HL                          ;
                        LD (IX+dW_Unk2),HL              ;

                        ; Undraw it

                        PUSH IX                         ;
                        POP IY                          ;
                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;
                        CALL RemoveLines                ;

                        ; Now, draw it

                        LD HL,(LB79D)                   ;
                        LD DE,(LB7A0)                   ;
                        LD BC,(LB7B0)                   ;
                        CALL ExplosionLine              ;
                        LD HL,$0000                     ;
LB79D                   EQU *-2                         ;
                        LD DE,$0000                     ;
LB7A0                   EQU *-2                         ;
                        LD BC,(LB7BD)                   ;
                        CALL ExplosionLine              ;
                        LD HL,$0000                     ;
LB7AA                   EQU *-2                         ;
                        LD DE,$0000                     ;
LB7AD                   EQU *-2                         ;
                        LD BC,$0000                     ;
LB7B0                   EQU *-2                         ;
                        CALL ExplosionLine              ;
                        LD HL,(LB7AA)                   ;
                        LD DE,(LB7AD)                   ;
                        LD BC,$0000                     ;
LB7BD                   EQU *-2                         ;
                        CALL ExplosionLine              ;
                        LD HL,(LB7A0)                   ;
                        LD DE,(LB7AA)                   ;
                        LD BC,$0000                     ;
LB7CA                   EQU *-2                         ;
                        CALL ExplosionLine              ;
                        LD HL,(LB7A0)                   ;
                        LD DE,(LB7AA)                   ;
                        LD BC,$0000                     ;
LB7D7                   EQU *-2                         ;
                        JP ExplosionLine                ;

DrawSquareTower         LD HL,(TempX)                   ;
                        LD DE,(TempZ)                   ;
                        LD BC,$0100                     ;
                        OR A                            ;
                        SBC HL,BC                       ;
                        LD (LB861),HL                   ;

                        CALL ObjeDiv                    ;
                        LD (LB8AB),HL                   ;

                        LD HL,(TempX)                   ;
                        LD BC,$0100                     ;
                        ADD HL,BC                       ;
                        LD (LB86A),HL                   ;

                        CALL ObjeDiv                    ;
                        LD (LB8A0),HL                   ;

                        ; Visible in X?

                        LD DE,(LB8AB)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        ADD HL,DE                       ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        LD HL,-127                      ;
                        ADD HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        ; Visible in Y?

                        LD HL,(TempY)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB667),HL                   ;

                        LD HL,(GroundY)                 ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB8BF),HL                   ;

                        LD DE,(LB667)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        ADD HL,DE                       ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        EX DE,HL                        ;
                        LD BC,-127                      ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        ; Yes, visible

                        LD HL,(TempZ)                   ;
                        LD BC,$0200                     ;
                        ADD HL,BC                       ;
                        LD (TempZ),HL                   ;

                        EX DE,HL                        ;

                        LD HL,$0000                     ;
LB861                   EQU *-2                         ;
                        CALL ObjeDiv                    ;
                        LD (LB8AE),HL                   ;

                        LD HL,$0000                     ;
LB86A                   EQU *-2                         ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB89D),HL                   ;

                        LD HL,(TempY)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LBB24),HL                   ;

                        LD HL,(GroundY)                 ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LBC19),HL                   ;

                        ; Undraw the lines

                        PUSH IX                         ;
                        POP IY                          ;

                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;

                        CALL RemoveLines                ;

                        ; Draw the visible lines

                        LD HL,$0000                     ;
LB89D                   EQU *-2                         ;
                        LD BC,$0000                     ;
LB8A0                   EQU *-2                         ;
                        DEC BC                          ;
                        DEC HL                          ;
                        OR A                            ;
                        SBC HL,BC                       ;
                        JP P DST1                       ;

                        LD HL,$0000                     ;
LB8AB                   EQU *-2                         ;
                        LD BC,$0000                     ;
LB8AE                   EQU *-2                         ;
                        DEC HL                          ;
                        OR A                            ;
                        SBC HL,BC                       ;
                        JP P DST3                       ;

                        LD A,(LB668)                    ;
                        BIT 7,A                         ;
                        JR NZ DST2                      ;

                        LD HL,$0000                     ;
LB8BF                   EQU *-2                         ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8AB)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8A0)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LB667)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LB89D)                   ;
                        LD DE,(LB8AE)                   ;
                        LD BC,(LBB24)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8AB)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        CALL AnyLine                    ;

                        LD HL,(LB89D)                   ;
                        LD DE,(LB8A0)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        JP AnyLine                      ;

DST2                    LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8AB)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8A0)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LB667)                   ;
                        JP HoriLine                     ;

DST1                    LD A,(LB668)                    ;
                        BIT 7,A                         ;
                        JR NZ DST4                      ;

                        LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8AB)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8A0)                   ;
                        CALL VertLine                   ;

                        LD HL,(LBC19)                   ;
                        LD DE,(LBB24)                   ;
                        LD BC,(LB89D)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LB667)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LB89D)                   ;
                        LD DE,(LB8AE)                   ;
                        LD BC,(LBB24)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8AB)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        CALL AnyLine                    ;

                        LD HL,(LB89D)                   ;
                        LD DE,(LB8A0)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        JP AnyLine                      ;

DST4                    LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8AB)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8A0)                   ;
                        CALL VertLine                   ;

                        LD HL,(LBC19)                   ;
                        LD DE,(LBB24)                   ;
                        LD BC,(LB89D)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LB667)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LB89D)                   ;
                        LD DE,(LB8A0)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        JP AnyLine                      ;

DST3                    LD A,(LB668)                    ;
                        BIT 7,A                         ;
                        JR NZ LBA77                     ;

                        LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8AB)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8A0)                   ;
                        CALL VertLine                   ;

                        LD HL,(LBC19)                   ;
                        LD DE,(LBB24)                   ;
                        LD BC,(LB8AE)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LB667)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LB89D)                   ;
                        LD DE,(LB8AE)                   ;
                        LD BC,(LBB24)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8AB)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        CALL AnyLine                    ;

                        LD HL,(LB89D)                   ;
                        LD DE,(LB8A0)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        JP AnyLine                      ;

LBA77                   LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8AB)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8A0)                   ;
                        CALL VertLine                   ;

                        LD HL,(LBC19)                   ;
                        LD DE,(LBB24)                   ;
                        LD BC,(LB8AE)                   ;
                        CALL VertLine                   ;

                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LB667)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8AB)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        JP AnyLine                      ;

;

MoveObje_X4             LD HL,(TempX)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB8AE),HL                   ;
                        LD HL,(IX+dW_Unk1)              ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        EX DE,HL                        ;
                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LB8A0),HL                   ;
                        PUSH HL                         ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB8AB),HL                   ;
                        POP DE                          ;
                        EX DE,HL                        ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        ADD HL,DE                       ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        LD HL,-127                      ;
                        ADD HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        LD HL,(TempY)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LBB24),HL                   ;

                        LD HL,(IX+dW_Unk2)              ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        EX DE,HL                        ;
                        LD HL,$0000                     ;
LBB24                   EQU *-2                         ;
                        ADD HL,DE                       ;
                        LD (LB8BF),HL                   ;
                        PUSH HL                         ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB667),HL                   ;
                        POP DE                          ;
                        EX DE,HL                        ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        ADD HL,DE                       ;
                        LD BC,$0080                     ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        LD HL,$FF81                     ;
                        ADD HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

LBB4E                   PUSH IX                         ;
                        POP IY                          ;
                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;
                        CALL RemoveLines                ;
                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LB667)                   ;
                        CALL HoriLine                   ;
                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LB8BF)                   ;
                        CALL HoriLine                   ;
                        LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8AB)                   ;
                        CALL VertLine                   ;
                        LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8A0)                   ;
                        JP VertLine                     ;

MoveTunnelMouth         LD HL,(IX+dW_Unk2)              ;
                        DEC (IX+dObjeTimeToNextRecalc)  ;
                        JR NZ LBBAA                     ;

                        LD (IX+dObjeTimeToNextRecalc),30;
                        mNegHL()                        ;
                        LD (IX+dW_Unk2),HL              ;
LBBAA                   LD DE,(IX+dW_Unk1)              ;
                        ADD HL,DE                       ;
                        LD (IX+dW_Unk1),HL              ;
                        EX DE,HL                        ;
                        LD HL,$04C0                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB89D),HL                   ;
                        LD HL,$0060                     ;
                        ADD HL,DE                       ;
                        LD (LBC19),HL                   ;
LBBC8                   LD HL,(TempX)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB8AE),HL                   ;
                        LD HL,(LB89D)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        EX DE,HL                        ;
                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LB8A0),HL                   ;
                        PUSH HL                         ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB8AB),HL                   ;
                        POP DE                          ;
                        EX DE,HL                        ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        ADD HL,DE                       ;
                        LD BC,$0080                     ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        LD HL,$FF81                     ;
                        ADD HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        LD HL,(TempY)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LBB24),HL                   ;
                        LD HL,$0000                     ;
LBC19                   EQU *-2                         ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        EX DE,HL                        ;
                        LD HL,(LBB24)                   ;
                        ADD HL,DE                       ;
                        LD (LB8BF),HL                   ;
                        PUSH HL                         ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB667),HL                   ;
                        POP DE                          ;
                        EX DE,HL                        ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        ADD HL,DE                       ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        LD HL,-127                      ;
                        ADD HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        LD HL,(LB8AB)                   ;
                        LD (IX+dW_UnkA),HL              ;
                        LD HL,(LB8A0)                   ;
                        LD (IX+dW_UnkC),HL              ;
                        LD HL,(LB667)                   ;
                        LD (IX+dW_UnkB),HL              ;
                        LD HL,(LB8BF)                   ;
                        LD (IX+dW_UnkD),HL              ;
                        JP LBB4E                        ;

MoveObje_X6             LD HL,(IX+dW_Unk1)              ;
                        LD (LB89D),HL                   ;
                        LD HL,(IX+dW_Unk2)              ;
                        LD (LBC19),HL                   ;
                        JP LBBC8                        ;

MoveObje_X3             LD HL,(IX+dW_Unk2)              ;
                        DEC (IX+dObjeTimeToNextRecalc)  ;
                        JR NZ LBCA2                     ;

                        LD (IX+dObjeTimeToNextRecalc),30;
                        mNegHL()                        ;
                        LD (IX+dW_Unk2),HL              ;
LBCA2                   LD DE,(IX+dW_Unk1)              ;
                        ADD HL,DE                       ;
                        LD (IX+dW_Unk1),HL              ;
                        EX DE,HL                        ;
                        LD HL,$004C                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB89D),HL                   ;
                        LD (LBC19),HL                   ;
                        JP LBBC8                        ;

; Project a ship onto the screen - CF means not visible

ProjectShipToScreen     LD HL,(TempX)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB8AE),HL                   ;

                        LD HL,$0200                     ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB89D),HL                   ;

                        EX DE,HL                        ;

                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LB8A0),HL                   ;

                        PUSH HL                         ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB8AB),HL                   ;
                        POP DE                          ;
                        EX DE,HL                        ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        ; Visible in X?

                        ADD HL,DE                       ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        LD HL,-127                      ;
                        ADD HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        LD HL,(TempY)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LBB24),HL                   ;

                        LD HL,$0080                     ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LBC19),HL                   ;

                        EX DE,HL                        ;
                        LD HL,(LBB24)                   ;
                        ADD HL,DE                       ;
                        LD (LB8BF),HL                   ;

                        PUSH HL                         ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LB667),HL                   ;
                        POP DE                          ;

                        EX DE,HL                        ;

                        ; Visible in Y?

                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        ADD HL,DE                       ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        LD HL,-127                      ;
                        ADD HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        SCF                             ;
                        RET                             ;

DrawShip_Rand0          CALL RecalcShipMoveIfTime       ;
                        CALL ProjectShipToScreen        ;
                        RET NC                          ;

                        LD DE,(LB89D)                   ;
                        SRA D                           ;
                        RR E                            ;
                        SRA D                           ;
                        RR E                            ;
                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LBD82),HL                   ;
                        LD HL,(LB8AE)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBD85),HL                   ;
                        PUSH IX                         ;
                        POP IY                          ;
                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;
                        CALL RemoveLines                ;
                        LD A,$46                        ;
                        LD (Colour),A                   ;
                        LD HL,$0000                     ;
LBD82                   EQU *-2                         ;
                        LD DE,$0000                     ;
LBD85                   EQU *-2                         ;
                        LD BC,(LB667)                   ;
                        CALL HoriLine                   ;
                        LD A,$42                        ;
                        LD (Colour),A                   ;
                        LD HL,(LBD82)                   ;
                        LD DE,(LBD85)                   ;
                        LD BC,(LB8BF)                   ;
                        CALL HoriLine                   ;
                        LD A,$44                        ;
                        LD (Colour),A                   ;
                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LBB24)                   ;
                        JP HoriLine                     ;

DrawShip_Rand1          CALL RecalcShipMoveIfTime       ;
                        CALL ProjectShipToScreen        ;
                        RET NC                          ;

                        LD DE,(LB89D)                   ;
                        SRA D                           ;
                        RR E                            ;
                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LBE0B),HL                   ;
                        LD HL,(LB8AE)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBE0E),HL                   ;
                        SRA D                           ;
                        RR E                            ;
                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LBDF9),HL                   ;
                        LD HL,(LB8AE)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBDFC),HL                   ;
                        PUSH IX                         ;
                        POP IY                          ;
                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;
                        CALL RemoveLines                ;
                        LD A,$07                        ;
                        LD (Colour),A                   ;
                        LD HL,$0000                     ;
LBDF9                   EQU *-2                         ;
                        LD DE,$0000                     ;
LBDFC                   EQU *-2                         ;
                        LD BC,(LB667)                   ;
                        CALL HoriLine                   ;
                        LD A,$46                        ;
                        LD (Colour),A                   ;
                        LD HL,$0000                     ;
LBE0B                   EQU *-2                         ;
                        LD DE,$0000                     ;
LBE0E                   EQU *-2                         ;
                        LD BC,(LB8BF)                   ;
                        CALL HoriLine                   ;
                        LD A,$45                        ;
                        LD (Colour),A                   ;
                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LBB24)                   ;
                        JP HoriLine                     ;

DrawShip_Rand2          CALL RecalcShipMoveIfTime       ;
                        CALL ProjectShipToScreen        ;
                        RET NC                          ;

                        LD DE,(LB89D)                   ;
                        SRA D                           ;
                        RR E                            ;
                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LBE81),HL                   ;
                        LD HL,(LB8AE)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBE84),HL                   ;
                        SRA D                           ;
                        RR E                            ;
                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LBE6F),HL                   ;
                        LD HL,(LB8AE)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBE72),HL                   ;
                        PUSH IX                         ;
                        POP IY                          ;
                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;
                        CALL RemoveLines                ;
                        LD A,$46                        ;
                        LD (Colour),A                   ;
                        LD HL,$0000                     ;
LBE6F                   EQU *-2                         ;
                        LD DE,$0000                     ;
LBE72                   EQU *-2                         ;
                        LD BC,(LB8BF)                   ;
                        CALL HoriLine                   ;
                        LD A,$45                        ;
                        LD (Colour),A                   ;
                        LD HL,$0000                     ;
LBE81                   EQU *-2                         ;
                        LD DE,$0000                     ;
LBE84                   EQU *-2                         ;
                        LD BC,(LB667)                   ;
                        CALL HoriLine                   ;
                        LD A,$07                        ;
                        LD (Colour),A                   ;
                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LBB24)                   ;
                        JP HoriLine                     ;

DrawShip_Rand3          CALL RecalcShipMoveIfTime       ;
                        CALL ProjectShipToScreen        ;
                        RET NC                          ;

                        LD DE,(LB89D)                   ;
                        SRA D                           ;
                        RR E                            ;
                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LBEFE),HL                   ;
                        LD HL,(LB8AE)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBF01),HL                   ;
                        SRA D                           ;
                        RR E                            ;
                        LD HL,(LBF01)                   ;
                        ADD HL,DE                       ;
                        LD (LBF0B),HL                   ;
                        LD HL,(LBF01)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBF0E),HL                   ;
                        LD HL,(LBEFE)                   ;
                        ADD HL,DE                       ;
                        LD (LBF18),HL                   ;
                        LD HL,(LBEFE)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBF1B),HL                   ;
                        PUSH IX                         ;
                        POP IY                          ;
                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;
                        CALL RemoveLines                ;

                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LBB24)                   ;
                        CALL HoriLine                   ;

                        LD HL,$0000                     ;
LBEFE                   EQU *-2                         ;
                        LD DE,$0000                     ;
LBF01                   EQU *-2                         ;
                        LD BC,(LB667)                   ;

                        CALL HoriLine                   ;

                        LD HL,$0000                     ;
LBF0B                   EQU *-2                         ;
                        LD DE,$0000                     ;
LBF0E                   EQU *-2                         ;
                        LD BC,(LB8BF)                   ;

                        CALL HoriLine                   ;

                        LD HL,$0000                     ;
LBF18                   EQU *-2                         ;
                        LD DE,$0000                     ;
LBF1B                   EQU *-2                         ;
                        LD BC,(LB8BF)                   ;
                        JP HoriLine                     ;

        if false
                        CALL RecalcShipMoveIfTime       ;
                        CALL ProjectShipToScreen        ;
                        RET NC                          ;

                        LD DE,(LB89D)                   ;
                        SRA D                           ;
                        RR E                            ;
                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LBEFE),HL                   ;
                        LD HL,(LB8AE)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBF01),HL                   ;
                        SRA D                           ;
                        RR E                            ;
                        LD HL,(LB8AE)                   ;
                        ADD HL,DE                       ;
                        LD (LBF0B),HL                   ;
                        LD HL,(LB8AE)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBF0E),HL                   ;
                        LD HL,(LB667)                   ;
                        LD DE,(LBC19)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LBF1B),HL                   ;
                        PUSH IX                         ;
                        POP IY                          ;
                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;
                        CALL RemoveLines                ;

                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        LD BC,(LBB24)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LBEFE)                   ;
                        LD DE,(LBF01)                   ;
                        LD BC,(LB667)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LBEFE)                   ;
                        LD DE,(LBF01)                   ;
                        LD BC,(LB8BF)                   ;
                        CALL HoriLine                   ;

                        LD HL,(LBF0B)                   ;
                        LD DE,(LBF0E)                   ;
                        LD BC,(LBF1B)                   ;
                        JP HoriLine                     ;
        endif

; Draw a triangular tower

ObjeTriangleTower       LD HL,(TempX)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB8AB),HL                   ;

                        LD HL,(TempZ)                   ;
                        LD DE,$0200                     ;
                        ADD HL,DE                       ;
                        LD (TempZ),HL                   ;

                        EX DE,HL                        ;

                        LD HL,(TempX)                   ;
                        LD BC,$FF00                     ;
                        ADD HL,BC                       ;
                        LD (LB861),HL                   ;

                        CALL ObjeDiv                    ;
                        LD (LB8A0),HL                   ;

                        LD HL,(TempX)                   ;
                        LD BC,$0100                     ;
                        ADD HL,BC                       ;
                        LD (LB86A),HL                   ;

                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB8AE),HL                   ;

                        ; Is this visible in X?

                        LD DE,(LB8A0)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        ADD HL,DE                       ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        LD HL,-127                      ;
                        ADD HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        ; Is this visible in Y?

                        LD DE,(IX+dObjeZ)               ;
                        PUSH DE                         ;
                        LD HL,(TempY)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB667),HL                   ;
                        LD HL,(GroundY)                 ;
                        POP DE                          ;
                        CALL ObjeDiv                    ;
                        LD (LB8BF),HL                   ;
                        LD DE,(LB667)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        ADD HL,DE                       ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        LD HL,-127                      ;
                        ADD HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        ; It's visible

                        LD HL,(TempY)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LBB24),HL                   ;

                        LD HL,(GroundY)                 ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LBC19),HL                   ;

                        ; Undraw this object

                        PUSH IX                         ;
                        POP IY                          ;

                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;

                        CALL RemoveLines                ;

                        ; See which lines are visible and draw them

                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8AB)                   ;
                        DEC HL                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JR NZ LC0DD                     ;

                        LD HL,(LB8A0)                   ;
                        EX DE,HL                        ;
                        DEC HL                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JP NZ LC134                     ;

                        LD A,(LB668)                    ;
                        BIT 7,A                         ;
                        JR NZ LC08D                     ;

                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8A0)                   ;
                        LD BC,(LBB24)                   ;
                        CALL HoriLine                   ;

LC08D                   LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8AB)                   ;
                        CALL VertLine                   ;
                        LD HL,(LBC19)                   ;
                        LD DE,(LBB24)                   ;
                        LD BC,(LB8A0)                   ;
                        CALL VertLine                   ;
                        LD HL,(LBC19)                   ;
                        LD DE,(LBB24)                   ;
                        LD BC,(LB8AE)                   ;
                        CALL VertLine                   ;
                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        CALL AnyLine                    ;
                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8AB)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        JP AnyLine                      ;

LC0DD                   LD A,(LB668)                    ;
                        BIT 7,A                         ;
                        JR NZ LC105                     ;

                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8A0)                   ;
                        LD BC,(LBB24)                   ;
                        CALL HoriLine                   ;
                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8AB)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        CALL AnyLine                    ;
LC105                   LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8AB)                   ;
                        CALL VertLine                   ;
                        LD HL,(LBC19)                   ;
                        LD DE,(LBB24)                   ;
                        LD BC,(LB8A0)                   ;
                        CALL VertLine                   ;
                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        JP AnyLine                      ;

LC134                   LD A,(LB668)                    ;
                        BIT 7,A                         ;
                        JR NZ LC15C                     ;

                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8A0)                   ;
                        LD BC,(LBB24)                   ;
                        CALL HoriLine                   ;
                        LD HL,(LB8A0)                   ;
                        LD DE,(LB8AB)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        CALL AnyLine                    ;
LC15C                   LD HL,(LB8BF)                   ;
                        LD DE,(LB667)                   ;
                        LD BC,(LB8AB)                   ;
                        CALL VertLine                   ;
                        LD HL,(LBC19)                   ;
                        LD DE,(LBB24)                   ;
                        LD BC,(LB8AE)                   ;
                        CALL VertLine                   ;
                        LD HL,(LB8AE)                   ;
                        LD DE,(LB8AB)                   ;
                        EXX                             ;
                        LD HL,(LBB24)                   ;
                        LD DE,(LB667)                   ;
                        EXX                             ;
                        JP AnyLine                      ;

MoveObje_X2             LD HL,(TempX)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (LB8AB),HL                   ;
                        LD BC,$0080                     ;
                        ADD HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        SBC HL,BC                       ;
                        SBC HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        LD HL,(TempY)                   ;
                        LD DE,(TempZ)                   ;
                        CALL ObjeDiv                    ;
                        LD BC,$0080                     ;
                        ADD HL,BC                       ;
                        LD (LC2D2),HL                   ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET NZ                          ;

                        SBC HL,BC                       ;
                        SBC HL,BC                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        PUSH IX                         ;
                        POP IY                          ;
                        LD BC,$0032                     ; %%%% dObjeLines?
                        ADD IY,BC                       ;
                        LD HL,$00C8                     ;
                        CALL LC37E                      ;
                        LD (LC2F5),HL                   ;
                        LD (LC2F8),DE                   ;
                        LD HL,$0154                     ;
                        CALL LC37E                      ;
                        LD (LC2FF),HL                   ;
                        LD (LC302),DE                   ;
                        LD HL,$0190                     ;
                        CALL LC37E                      ;
                        LD (LC309),HL                   ;
                        LD (LC30C),DE                   ;
                        LD HL,$01B8                     ;
                        CALL LC37E                      ;
                        LD (LC313),HL                   ;
                        LD (LC316),DE                   ;
                        LD HL,$012C                     ;
                        LD DE,(TempZ)                   ;
                        CALL DivHLDE                    ;
                        LD A,L                          ;
                        OR H                            ;
                        JR NZ LC2CD                     ;

                        INC L                           ;
LC2CD                   LD C,L                          ;
                        LD B,H                          ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        LD DE,$0000                     ;
LC2D2                   EQU *-2                         ;
                        LD D,high DivTab                ;
                        LD A,(DE)                       ;
                        LD E,A                          ;
                        LD D,0                          ;
                        EX DE,HL                        ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        PUSH HL                         ;
                        ADD HL,BC                       ;
                        PUSH HL                         ;
                        ADD HL,BC                       ;
                        PUSH HL                         ;
                        ADD HL,BC                       ;
                        PUSH HL                         ;
                        ADD HL,BC                       ;
                        PUSH HL                         ;
                        ADD HL,BC                       ;
                        PUSH HL                         ;
                        ADD HL,BC                       ;
                        PUSH HL                         ;
                        ADD HL,BC                       ;
                        PUSH HL                         ;
                        ADD HL,BC                       ;
                        PUSH HL                         ;
                        CALL RemoveLines                ;
                        LD HL,$0000                     ;
LC2F5                   EQU *-2                         ;
                        LD DE,$0000                     ;
LC2F8                   EQU *-2                         ;
                        POP BC                          ;
                        CALL LC350                      ;
                        LD HL,$0000                     ;
LC2FF                   EQU *-2                         ;
                        LD DE,$0000                     ;
LC302                   EQU *-2                         ;
                        POP BC                          ;
                        CALL LC350                      ;
                        LD HL,$0000                     ;
LC309                   EQU *-2                         ;
                        LD DE,$0000                     ;
LC30C                   EQU *-2                         ;
                        POP BC                          ;
                        CALL LC350                      ;
                        LD HL,$0000                     ;
LC313                   EQU *-2                         ;
                        LD DE,$0000                     ;
LC316                   EQU *-2                         ;
                        POP BC                          ;
                        CALL LC350                      ;
                        LD HL,(LC313)                   ;
                        LD DE,(LC316)                   ;
                        POP BC                          ;
                        CALL LC350                      ;
                        LD HL,(LC313)                   ;
                        LD DE,(LC316)                   ;
                        POP BC                          ;
                        CALL LC350                      ;
                        LD HL,(LC309)                   ;
                        LD DE,(LC30C)                   ;
                        POP BC                          ;
                        CALL LC350                      ;
                        LD HL,(LC2FF)                   ;
                        LD DE,(LC302)                   ;
                        POP BC                          ;
                        CALL LC350                      ;
                        LD HL,(LC2F5)                   ;
                        LD DE,(LC2F8)                   ;
                        POP BC                          ;
LC350                   LD A,C                          ;
                        SRA B                           ;
                        RRA                             ;
                        SRA B                           ;
                        RRA                             ;
                        BIT 7,B                         ;
                        SCF                             ;
                        RET NZ                          ;

                        CP $0C                          ;
LC35D                   RET C                           ;

                        CP $9E                          ;
LC35F                   EQU *-1                         ;
                        CCF                             ;
LC361                   RET C                           ;

                        PUSH HL                         ;
                        LD L,A                          ;
                        JP LA561                        ;

RemoveLines             PUSH IY                         ;

RLlp                    LD HL,(IY+AnypCode)             ;
                        CALL CallHL                     ;

                        LD BC,lObjeLine                 ;
                        ADD IY,BC                       ;

                        JP RLlp                         ;

RemoveLineExit          POP AF                          ;
                        POP IY                          ;
                        RET                             ;

LC37E                   LD DE,(TempZ)                   ;
                        SRA D                           ;
                        RR E                            ;
                        CALL DivHLDE                    ;
                        SRA H                           ;
                        RR L                            ;
                        LD C,L                          ;
                        LD B,H                          ;
                        LD DE,(LB8AB)                   ;
                        ADD HL,DE                       ;
                        EX DE,HL                        ;
                        PUSH DE                         ;
                        LD H,C                          ;
                        LD L,$00                        ;
                        LD DE,(LB8AB)                   ;
                        CALL SignMult                   ;
LC3A0                   LD C,H                          ;
                        LD B,0                          ;
                        BIT 7,C                         ;
                        JR Z LC3A9                      ;

                        LD B,$FF                        ;
LC3A9                   POP DE                          ;
                        LD HL,(LB8AB)                   ;
                        OR A                            ;
                        ADD HL,BC                       ;
                        EX DE,HL                        ;
                        RET                             ;

; Clear all the objects

ClearObjects            LD IX,ObjeTable                 ;
                        LD B,nObjes                     ;

ClearObject_Lp          PUSH BC                         ;

                        BIT 0,(IX+dObjeFlag)            ; Alive?
                        JR Z ClearObject_Next           ; No, skip

                        LD HL,(IX+dObjeMissed)          ;
                        CALL CallHL                     ;

                        ; Undraw it

                        PUSH IX                         ;
                        POP IY                          ;
                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;
                        CALL RemoveLines                ;

ClearObject_Next        POP BC                          ;
                        LD DE,lObje                     ;
                        ADD IX,DE                       ;
                        DJNZ ClearObject_Lp             ;

                        RET                             ;

; Find a free one

FindFreeObje            LD IY,ObjeTable                 ;
                        LD B,nObjes-1                   ;
                        LD DE,lObje                     ;
FFO_Lp                  OR A                            ;
                        BIT 0,(IY+dObjeFlag)            ;
                        RET Z                           ;

                        ADD IY,DE                       ;
                        DJNZ FFO_Lp                     ;

                        SCF                             ;
                        RET                             ;

; Tables

ExplosionOfMissile      DEFB $1E,$0F,$04,$23,$16,$44,$28,$1E
                        DEFB $05,$2D,$25,$45,$32,$2D,$06,$37
                        DEFB $34,$46,$3C,$3C,$07,$41,$43,$47
                        DEFB $46,$4B,$46,$4B,$52,$45,$50,$5A
                        DEFB $44,$55,$61,$43,$5A,$69,$42,$5F
                        DEFB $70,$41,$00,$00,$00

ExplosionOfObject       DEFB $3C,$0F,$04
                        DEFB $46,$16,$44,$50,$1E,$05,$5A,$25
                        DEFB $45,$64,$2D,$06,$6E,$34,$46,$78
                        DEFB $3C,$07,$82,$43,$47,$8C,$4B,$46
                        DEFB $96,$52,$45,$A0,$5A,$44,$AA,$61
                        DEFB $43,$B4,$69,$42,$BE,$70,$41,$00
                        DEFB $00,$00

Tunnel_A                DEFW $0000,$0000,$0080,$FFC0
                        DEFB $10,$00
                        DEFW $0800,$FC00,$FF00,$FF80
                        DEFB $08,$00
                        DEFW $0000,$F800,$0200,$0100
                        DEFB $08,$00
                        DEFW $1000,$0000,$FC00,$0000
                        DEFB $04,$00
                        DEFW $0000,$0000,$FB00,$FE00
                        DEFB $05,$00
                        DEFW $E700,$F600,$0500,$0200
                        DEFB $05,$00
                        DEFW $0000,$0000,$FC00,$0100
                        DEFB $06,$00
                        DEFW $E800,$0600,$0200,$FF80
                        DEFB $0C,$00
                        DEFW $0000,$0000,$0000,$0000
                        DEFB $00,$00

Tunnel_B                DEFW $0000,$0000,$0100,$0200
                        DEFB $08,$00
                        DEFW $0800,$1000,$FF00,$FE00
                        DEFB $10,$00
                        DEFW $F800,$F000,$0200,$0400
                        DEFB $04,$00
                        DEFW $0000,$0000,$FD00,$0600
                        DEFB $04,$00
                        DEFW $F400,$1800,$0180,$FD00
                        DEFB $08,$00
                        DEFW $0000,$0000,$0000,$0000
                        DEFB $00,$00

Tunnel_C                DEFW $0000,$0000,$FF80,$0040
                        DEFB $04,$00
                        DEFW $FE00,$0100,$FF00,$0080
                        DEFB $04,$00
                        DEFW $FA00,$0300,$FE00,$0100
                        DEFB $04,$00
                        DEFW $F200,$0700,$0200,$FF00
                        DEFB $07,$00
                        DEFW $0000,$0000,$FC00,$0400
                        DEFB $04,$00
                        DEFW $F000,$1000,$0400,$FC00
                        DEFB $02,$00
                        DEFW $F800,$0800,$0200,$FE00
                        DEFB $04,$00
                        DEFW $0000,$0000,$0000,$0000
                        DEFB $00,$00

Tunnel_D                DEFW $0000,$0000,$0200,$FF80
                        DEFB $08,$00
                        DEFW $1000,$FC00,$FC00,$0100
                        DEFB $04,$00
                        DEFW $0000,$0000,$FA00,$0180
                        DEFB $03,$00
                        DEFW $EE00,$0480,$0300,$FF40
                        DEFB $06,$00
                        DEFW $0000,$0000,$FE00,$0080
                        DEFB $08,$00
                        DEFW $F000,$0400,$0100,$FFC0
                        DEFB $10,$00
                        DEFW $0000,$0000,$0000,$0000
                        DEFB $00,$00

Tunnel_E                DEFW $0000,$0000,$FF80,$0040
                        DEFB $10,$00
                        DEFW $F800,$0400,$0080,$FFC0
                        DEFB $20,$00
                        DEFW $0800,$0400,$FE00,$FF00
                        DEFB $04,$00
                        DEFW $0000,$0000,$FF80,$FFC0
                        DEFB $20,$00
                        DEFW $F000,$F800,$0100,$0080
                        DEFB $10,$00
                        DEFW $0000,$0000,$0000,$0000
                        DEFB $00,$00

TunnelTypeTable         DEFW Tunnel_A,Tunnel_B,Tunnel_C,Tunnel_D
                        DEFW Tunnel_E,Tunnel_C,Tunnel_D,Tunnel_E
                        DEFW Tunnel_A,Tunnel_B,Tunnel_C,Tunnel_D
                        DEFW Tunnel_E,Tunnel_C,Tunnel_D,Tunnel_E

LC593                   DEFB $07,$00,$F0
                        DEFB $07,$00,$10
                        DEFB $00
                        DEFB $02,$00,$00
                        DEFB $00
                        DEFB $01,$00,$E0
                        DEFB $01,$00,$20
                        DEFB $00
                        DEFB $00
                        DEFB $05,$00,$00
                        DEFB $00
                        DEFB $08,$00,$00
                        DEFB $00
                        DEFB $00
                        DEFB $05,$00,$00
                        DEFB $00
                        DEFB $03,$00,$F8
                        DEFB $03,$00,$08
                        DEFB $00
                        DEFB $00
                        DEFB $00
                        DEFB $00
                        DEFB $06,$00,$00
                        DEFB $00
                        DEFB $00
                        DEFB $00
                        DEFB $00
                        DEFB $00

LC5C5                   DEFB $02,$00,$00
                        DEFB $00
                        DEFB $0A,$00,$E0
                        DEFB $00
                        DEFB $02,$00,$F0
                        DEFB $00
                        DEFB $0A,$00,$00
                        DEFB $00
                        DEFB $02,$00,$10
                        DEFB $00
                        DEFB $0A,$00,$20
                        DEFB $00
                        DEFB $02,$00,$00
                        DEFB $00
                        DEFB $0A,$00,$E0
                        DEFB $00
                        DEFB $02,$00,$00
                        DEFB $00
                        DEFB $0A,$00,$20
                        DEFB $00
                        DEFB $02,$00,$00
                        DEFB $00
                        DEFB $0A,$00,$E0
                        DEFB $00
                        DEFB $02,$00,$00
                        DEFB $00
                        DEFB $0A,$00,$20
                        DEFB $00
                        DEFB $02,$00,$00
                        DEFB $00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00

LC61E                   DEFB $09,$00,$00
                        DEFB $00
                        DEFB $00
                        DEFB $02,$00,$00
                        DEFB $00
                        DEFB $00
                        DEFB $09,$00,$00
                        DEFB $00
                        DEFB $00
                        DEFB $02,$00,$00
                        DEFB $00
                        DEFB $00
                        DEFB $09,$00,$00
                        DEFB $00
                        DEFB $00
                        DEFB $09,$00,$00
                        DEFB $00
                        DEFB $00
                        DEFB $01,$00,$E0
                        DEFB $01,$00,$20
                        DEFB $00
                        DEFB $09,$00,$00
                        DEFB $00
                        DEFB $09,$00,$00
                        DEFB $00
                        DEFB $00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00


