; Player bits

AlterSteps              CALL ReadKey_Decc               ;
                        JR NZ AS0                       ;

                        CALL ReadKey_Acc                ;
                        JR Z AS20                       ;

                        LD DE,Zdvstep                   ;
                        JR AS1                          ;

AS0                     LD DE,-Zdvstep                  ;

AS1                     LD HL,(DeltaZ)                  ;
                        ADD HL,DE                       ;

                        LD DE,MinSP                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JR Z AS2                        ;

                        ADD HL,DE                       ;
                        LD DE,MaxSP                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JR NZ AS2                       ;

                        ADD HL,DE                       ;
                        EX DE,HL                        ;

AS2                     EX DE,HL                        ;
                        LD (DeltaZ),HL                  ;

                        ; Now, L/R/U/D

AS20                    ld a,(bUseAnalog_JS)            ;
                        or a
                        jp nz Player_UseAnaJS

                        ; Read digital UDLR

                        CALL ReadKey_L                  ;
                        JR NZ AS21                      ;

                        CALL ReadKey_R                  ;
                        JP Z AS23                       ;

                        LD A,2                          ;
                        JR AS22                         ;

AS21                    CALL ReadKey_R                  ;
                        JR NZ AS23                      ;

                        LD A,1                          ;
AS22                    LD B,A                          ;
                        LD A,(OldX)                     ;
                        CP B                            ;
                        JR Z AS2a                       ;

                        LD HL,Xdtstep                   ;
                        LD (Xvar),HL                    ;
AS2a                    LD HL,(Xvar)                    ;
                        LD DE,dDX                       ;
                        ADD HL,DE                       ;
                        LD (Xvar),HL                    ;
                        EX DE,HL                        ;
                        LD HL,(XTurnRatio)              ;
                        LD A,B                          ;
                        LD (OldX),A                     ;
                        BIT 0,A                         ;
                        CALL ASMakeTurn                 ;
                        LD (XTurnRatio),HL              ;
                        JR AS3                          ;

AS23                    LD DE,Xdtstep                   ;
                        LD (Xvar),DE                    ;

AS3                     CALL ReadKey_U                  ;
                        JR NZ AS30                      ;

                        CALL ReadKey_D                  ;
                        JR Z AS32                       ;

                        LD A,2                          ;
                        JR AS31                         ;

AS30                    CALL ReadKey_D                  ;
                        JR NZ AS32                      ;

                        LD A,1                          ;
AS31                    LD B,A                          ;
                        LD A,(OldY)                     ;
                        CP B                            ;
                        JR Z AS3a                       ;

                        LD HL,Ydtstep                   ;
                        LD (Yvar),HL                    ;
AS3a                    LD HL,(Yvar)                    ;
                        LD DE,dDY                       ;
                        ADD HL,DE                       ;
                        LD (Yvar),HL                    ;
                        LD A,B                          ;
                        LD (OldY),A                     ;
                        BIT 0,A                         ;
                        EX DE,HL                        ;
                        LD HL,(YDiveRatio)              ;
                        CALL ASMakeTurn                 ;
                        LD (YDiveRatio),HL              ;
                        JP Player_ControlsDone          ;

; We want to use the analog joystick

Player_UseAnaJS         ld bc,$FBDF                     ; JoyX
                        in l,(c)
                        ld h,0
                        bit 7,l
                        jr z PUX_1
                        dec h
PUX_1                   add hl,hl

                        ld (XTurnRatio),hl

                        ; Get Y

                        ld bc,$FFDF                     ; JoyY
                        in l,(c)
                        ld h,0
                        bit 7,l
                        jr z PUY_1
                        dec h
PUY_1                   add hl,hl

                        ld (YDiveRatio),hl

                        ; Right, assume that's done

                        jp Player_ControlsDone

;

AS32                    LD HL,Ydtstep                   ;
                        LD (Yvar),HL                    ;

                        ; Fall into

Player_ControlsDone     LD A,(GameMode_SPT)             ;
                        OR A                            ;
                        JR NZ AS5                       ;

                        LD A,(YDiveRatio+1)             ;
                        BIT 7,A                         ;
                        JR Z AS4a                       ;

                        LD HL,HighY                     ;
                        CALL Inner                      ;
                        JR NZ AS5                       ;

                        PUSH HL                         ;
                        LD A,(YDiveRatio)               ;
                        CP $10                          ;
                        JR NC PCD0                      ;

                        LD A,(optGameFormat)            ;
                        DEC A                           ;
                        JR Z PCD1                       ;

                        LD A,(nBasesOnPlanet)           ;
                        OR A                            ;
                        JR NZ PCD0                      ;

PCD1                    LD HL,(DeltaZ)                  ;
                        LD DE,$0320                     ;
                        ADD HL,DE                       ;
                        JR NC PCD2                      ;

PCD0                    POP HL                          ;
                        JR AS4c                         ;

PCD2                    POP HL                          ;
                        CALL AS5                        ;
                        SCF                             ;
                        RET                             ;

;                        DEFW $0818                      ;

AS4a                    LD HL,LowY                      ;
                        CALL Inner                      ;
                        JR Z AS5                        ;

AS4c                    LD (YDiveRatio),HL              ;
AS5                     LD HL,(DeltaZ)                  ;
                        LD DE,(YDiveRatio)              ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        CALL SignMult                   ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        LD (DeltaY),HL                  ;
                        mNegHL()                        ;
                        ADD HL,HL                       ;
                        LD (FireDY),HL                  ;

                        LD DE,(XTurnRatio)              ;
                        LD HL,(DeltaZ)                  ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        CALL SignMult                   ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        LD (DeltaX),HL                  ;

                        mNegHL()                        ;
                        ADD HL,HL                       ;
                        LD (FireDX),HL                  ;

                        LD HL,(DeltaZ)                  ;
                        mNegHL()                        ;
                        ADD HL,HL                       ;
                        LD (FireDZ),HL                  ;

                        LD DE,ProjSP                    ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        OR A                            ;
                        BIT 7,H                         ;
                        RET Z                           ;

                        LD (FireDZ),DE                  ;
                        LD HL,ProjSP                    ;
                        LD DE,(YDiveRatio)              ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        CALL SignMult                   ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        LD (FireDY),HL                  ;
                        LD HL,ProjSP                    ;
                        LD DE,(XTurnRatio)              ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        CALL SignMult                   ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        LD (FireDX),HL                  ;
                        OR A                            ;
                        RET                             ;

Inner                   LD DE,(GroundY)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        SRA H                           ;
                        RR L                            ;
                        SRA H                           ;
                        RR L                            ;
                        LD DE,(DeltaZ)                  ;
                        EX DE,HL                        ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        EX DE,HL                        ;
                        CALL SignDiv                    ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        LD DE,(YDiveRatio)              ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        ADD HL,DE                       ;
                        RET                             ;

Xvar                    DEFW 3                          ;
OldX                    DEFB 0                          ;

Yvar                    DEFW 1
OldY                    DEFB 0                          ;

ASMakeTurn              JR Z ASMT1                      ;

                        ; Negate DE

                        LD A,D                          ;
                        CPL                             ;
                        LD D,A                          ;
                        LD A,E                          ;
                        CPL                             ;
                        LD E,A                          ;
                        INC DE                          ;

ASMT1                   ADD HL,DE                       ;
                        BIT 7,H                         ;
                        JR NZ ASMT2                     ;

                        DEC H                           ;
                        INC H                           ;
                        RET Z                           ;

                        LD HL,$00FF                     ;
                        RET                             ;

ASMT2                   INC H                           ;
                        JR NZ ASMT2a                    ;

                        DEC H                           ;
                        RET                             ;

ASMT2a                  LD HL,$FF00                     ;
                        RET                             ;


