; Key code built here...

Game_Start              xor a
                        ld (bUseAnalog_JS),a

                        LD A,(KeyOrJoystick)
                        CP $4A
                        JR Z Use_Joystick

                        CALL Compile_UDK
                        JP GameControlsDone

; We want a joystick so build the keys and copy over the first 4 + fire

Use_Joystick            CALL Compile_UDK
                        LD A,(JoystickType)

                        cp 5                    ; Analog joystick
                        jr z UJ_AnalogJS

                        LD L,A
                        LD H,0

                        ; * 10

                        ADD HL,HL
                        LD D,H
                        LD E,L
                        ADD HL,HL
                        ADD HL,HL
                        ADD HL,DE
                        ; + Base
                        LD DE,JoyInputTable - 10
                        ADD HL,DE
                        LD DE,ReadKey_L

                        ; Copy LRUD

                        LD B,4
UJ_Lp                   CALL CopyAJoystickVector
                        DJNZ UJ_Lp

                        ; Skip Acc/decc

                        INC DE
                        INC DE
                        INC DE
                        INC DE
                        INC DE
                        INC DE

                        ; Copy Fire

                        CALL CopyAJoystickVector
                        JP GameControlsDone

; Set the analog JS flag

UJ_AnalogJS             ld a,1
                        ld (bUseAnalog_JS),a

                        jp GameControlsDone

CopyAJoystickVector     INC DE
                        LD A,(HL)
                        LD (DE),A
                        INC HL
                        INC DE
                        LD A,(HL)
                        LD (DE),A
                        INC HL
                        INC DE
                        RET


JoyInputTable           DEFW JS_Kem_L,JS_Kem_R,JS_Kem_U,JS_Kem_D,JS_Kem_F
                        DEFW JS_Ful_L,JS_Ful_R,JS_Ful_U,JS_Ful_D,JS_Ful_F
                        DEFW JS_Pro_L,JS_Pro_R,JS_Pro_U,JS_Pro_D,JS_Pro_F
                        DEFW JS_Sin_L,JS_Sin_R,JS_Sin_U,JS_Sin_D,JS_Sin_F
                        DEFW JS_Par_L,JS_Par_R,JS_Par_U,JS_Par_D,JS_Par_F

JS_Kem_L                IN A,($1F)
                        BIT 1,A
                        RET

JS_Kem_R                IN A,($1F)
                        BIT 0,A
                        RET

JS_Kem_U                IN A,($1F)
                        BIT 3,A
                        RET

JS_Kem_D                IN A,($1F)
                        BIT 2,A
                        RET

JS_Kem_F                IN A,($1F)
                        BIT 4,A
                        RET

JS_Ful_L                IN A,($7F)
                        CPL
                        BIT 2,A
                        RET

JS_Ful_R                IN A,($7F)
                        CPL
                        BIT 3,A
                        RET

JS_Ful_U                IN A,($7F)
                        CPL
                        BIT 0,A
                        RET

JS_Ful_D                IN A,($7F)
                        CPL
                        BIT 1,A
                        RET

JS_Ful_F                IN A,($7F)
                        CPL
                        BIT 7,A
                        RET

JS_Pro_L                LD A,$F7
                        IN A,($FE)
                        CPL
                        BIT 4,A
                        RET

JS_Pro_R                LD A,$EF
                        IN A,($FE)
                        CPL
                        BIT 2,A
                        RET

JS_Pro_U                LD A,$EF
                        IN A,($FE)
                        CPL
                        BIT 3,A
                        RET

JS_Pro_D                LD A,$EF
                        IN A,($FE)
                        CPL
                        BIT 4,A
                        RET

JS_Pro_F                LD A,$EF
                        IN A,($FE)
                        CPL
                        BIT 0,A
                        RET

JS_Sin_L                LD A,$EF
                        IN A,($FE)
                        CPL
                        BIT 4,A
                        RET

JS_Sin_R                LD A,$EF
                        IN A,($FE)
                        CPL
                        BIT 3,A
                        RET

JS_Sin_U                LD A,$EF
                        IN A,($FE)
                        CPL
                        BIT 1,A
                        RET

JS_Sin_D                LD A,$EF
                        IN A,($FE)
                        CPL
                        BIT 2,A
                        RET

JS_Sin_F                LD A,$EF
                        IN A,($FE)
                        CPL
                        BIT 0,A
                        RET

JS_Par_L                IN A,($1F)
                        BIT 0,A
                        RET

JS_Par_R                IN A,($1F)
                        BIT 1,A
                        RET

JS_Par_U                IN A,($1F)
                        BIT 2,A
                        RET

JS_Par_D                IN A,($1F)
                        BIT 3,A
                        RET

JS_Par_F                IN A,($1F)
                        BIT 4,A
                        RET

Compile_UDK             LD IX,ReadKey_L                 ; 9B2E
                        LD IY,UDK_Code                  ; 9B32
                        LD DE,UDK_Left                  ; 9B36
                        LD B,8                          ; 9B39
L9B3B                   PUSH BC                         ; 9B3B
                        PUSH DE                         ; 9B3C
                        LD HL,HS_Buffer                 ; 9B3D
L9B40                   LD A,(DE)                       ; 9B40
                        CP $28                          ; 9B41
                        JR NC L9B61                     ; 9B43

                        CALL L9B4F                      ; 9B45
                        LD (HL),B                       ; 9B48
                        INC HL                          ; 9B49
                        LD (HL),C                       ; 9B4A
                        INC HL                          ; 9B4B
                        INC DE                          ; 9B4C
                        JR L9B40                        ; 9B4D

L9B4F                   LD BC,$FEFE                     ; 9B4F
                        INC A                           ; 9B52
L9B53                   DEC A                           ; 9B53
                        RET Z                           ; 9B54

                        RLC C                           ; 9B55
                        BIT 5,C                         ; 9B57
                        JR NZ L9B53                     ; 9B59

                        LD C,$FE                        ; 9B5B
                        RLC B                           ; 9B5D
                        JR L9B53                        ; 9B5F

L9B61                   LD (HL),$00                     ; 9B61
                        LD DE,HS_Buffer-2               ; 9B63
L9B66                   INC DE                          ; 9B66
                        INC DE                          ; 9B67
                        LD A,(DE)                       ; 9B68
                        OR A                            ; 9B69
                        JR Z L9B88                      ; 9B6A

                        LD H,D                          ;
                        LD L,E                          ;

L9B6E                   INC HL                          ; 9B6E
                        INC HL                          ; 9B6F
                        EX AF,AF'                       ; 9B70
                        LD A,(HL)                       ; 9B71
                        OR A                            ; 9B72
                        JR Z L9B66                      ; 9B73

                        EX AF,AF'                       ; 9B75
                        CP (HL)                         ; 9B76
                        JR NZ L9B6E                     ; 9B77

                        INC DE                          ; 9B79
                        INC HL                          ; 9B7A
                        EX AF,AF'                       ; 9B7B
                        LD A,(DE)                       ; 9B7C
                        AND (HL)                        ; 9B7D
                        LD (DE),A                       ; 9B7E
                        EX AF,AF'                       ; 9B7F
                        LD (HL),$FF                     ; 9B80
                        DEC HL                          ; 9B82
                        DEC DE                          ; 9B83
                        LD (HL),$FF                     ; 9B84
                        JR L9B6E                        ; 9B86

L9B88                   LD DE,HS_Buffer-2               ; 9B88
L9B8B                   INC DE                          ; 9B8B
                        INC DE                          ; 9B8C
                        LD A,(DE)                       ; 9B8D
                        OR A                            ; 9B8E
                        JR Z L9BB3                      ; 9B8F

                        CP $FF                          ; 9B91
                        JR Z L9B8B                      ; 9B93

                        INC DE                          ; 9B95
                        LD A,(DE)                       ; 9B96
                        DEC DE                          ; 9B97
                        LD H,D                          ; 9B98
                        LD L,E                          ; 9B99
                        INC HL                          ; 9B9A
L9B9B                   INC HL                          ; 9B9B
                        EX AF,AF'                       ; 9B9C
                        LD A,(HL)                       ; 9B9D
                        OR A                            ; 9B9E
                        JR Z L9B8B                      ; 9B9F

                        EX AF,AF'                       ; 9BA1
                        INC HL                          ; 9BA2
                        CP (HL)                         ; 9BA3
                        JR NZ L9B9B                     ; 9BA4

                        DEC HL                          ; 9BA6
                        EX AF,AF'                       ; 9BA7
                        LD A,(DE)                       ; 9BA8
                        AND (HL)                        ; 9BA9
                        LD (DE),A                       ; 9BAA
                        EX AF,AF'                       ; 9BAB
                        LD (HL),$FF                     ; 9BAC
                        INC HL                          ; 9BAE
                        LD (HL),$FF                     ; 9BAF
                        JR L9B9B                        ; 9BB1

L9BB3                   LD (IX ),$C3                    ; 9BB3
                        LD A,IYL                        ; 9BB7
                        LD (IX +1),A                    ; 9BB9
                        LD A,IYH                        ; 9BBC
                        LD (IX +2),A                    ; 9BBE
                        INC IX                          ; 9BC1
                        INC IX                          ; 9BC3
                        INC IX                          ; 9BC5
                        LD HL,HS_Buffer-2               ; 9BC7
L9BCA                   INC HL                          ; 9BCA
                        INC HL                          ; 9BCB
L9BCC                   LD A,(HL)                       ; 9BCC
                        OR A                            ; 9BCD
                        JR Z L9C08                      ; 9BCE

                        CP $FF                          ; 9BD0
                        JR Z L9BCA                      ; 9BD2

                        LD (IY ),$3E                     ; 9BD4
                        INC IY                          ; 9BD8
                        LD A,(HL)                       ; 9BDA
                        INC HL                          ; 9BDB
                        LD (IY ),A                       ; 9BDC
                        INC IY                          ; 9BDF
                        LD (IY ),$DB                     ; 9BE1
                        INC IY                          ; 9BE5
                        LD (IY ),$FE                     ; 9BE7
                        INC IY                          ; 9BEB
                        LD (IY ),$F6                     ; 9BED
                        INC IY                          ; 9BF1
                        LD A,(HL)                       ; 9BF3
                        INC HL                          ; 9BF4
                        LD (IY ),A                       ; 9BF5
                        INC IY                          ; 9BF8
                        LD (IY ),$3C                     ; 9BFA
                        INC IY                          ; 9BFE
                        LD (IY ),$C0                     ; 9C00
                        INC IY                          ; 9C04
                        JR L9BCC                        ; 9C06

L9C08                   LD (IY -1),$C9                   ; 9C08
                        POP DE                          ; 9C0C
                        POP BC                          ; 9C0D
                        LD A,E                          ; 9C0E
                        OR $0F                          ; 9C0F
                        LD E,A                          ; 9C11
                        INC DE                          ; 9C12
                        DEC B                           ; 9C13
                        JP NZ L9B3B                     ; 9C14

                        RET                             ; 9C17


